/*
 *
 *    Copyright (C) 2004-2006 NERC DataGrid
 *    This software may be distributed under the terms of the
 *    CCLRC Licence for CCLRC Software
 * <CDATDIR>/External_License/CCLRC_CDAT_License.txt 
 *
 */
#ifdef HAVE_PP
#include "cdunifpp.h"

/* The data for these functions is taken from xconv v1.90 */

/* returns string, or NULL if not matched */
char *pp_pplongname(int code)
{
  switch (code) {
  case    0: return "Unspecified";
  case    1: return "Height";
  case    2: return "Depth";
  case    3: return "Geopotential (= g*height)";
  case    4: return "ICAO height";
  case    5: return "Boundary layer height";
  case    6: return "Non-dimensional soil model level";
  case    7: return "Exner pressure";
  case    8: return "Pressure";
  case    9: return "Hybrid pressure";
  case   10: return "Sigma (= p/surface p)";
  case   11: return "T*u";
  case   12: return "T*v";
  case   13: return "T**2";
  case   14: return "T*omega";
  case   15: return "Height**2";
  case   16: return "Temperature T";
  case   17: return "Dew point temperature";
  case   18: return "Dew point depression";
  case   19: return "Potential temperature";
  case   20: return "Maximum temperature";
  case   21: return "Minimum temperature";
  case   22: return "Wet bulb potential temperature";
  case   23: return "Soil temperature (levels 2,3,4)";
  case   24: return "d theta/dt";
  case   25: return "Visibility";
  case   26: return "Brunt-Vaisala Frequency N";
  case   27: return "(Atmospheric) density";
  case   28: return "d(p*)/dt .  p* = surface pressure";
  case   29: return "Cloud fraction below a level in feet";
  case   30: return "Total cloud";
  case   31: return "High cloud";
  case   32: return "Medium cloud";
  case   33: return "Low cloud";
  case   34: return "Convective cloud";
  case   35: return "Contrail";
  case   36: return "Fractional land amount";
  case   37: return "Fractional sea-ice cover";
  case   38: return "Atmospheric model land/sea mask   Land=1, Sea=0";
  case   39: return "Coriolis parameter";
  case   40: return "Omega  (= dp/dt)";
  case   41: return "Wet bulb temperature";
  case   42: return "Vertical velocity  (= dz/dt)";
  case   43: return "Eta dot";
  case   44: return "Time in seconds";
  case   45: return "d(sigma)/dt";
  case   46: return "u*q";
  case   47: return "v*q";
  case   48: return "x wind component (with respect to grid)";
  case   49: return "y wind component (with respect to grid)";
  case   50: return "Wind speed";
  case   51: return "Thermal wind speed";
  case   52: return "Vertical speed shear";
  case   53: return "u*omega";
  case   54: return "v*omega";
  case   55: return "Wind direction";
  case   56: return "Westerly component of wind  u";
  case   57: return "Southerly component of wind v";
  case   58: return "u**2";
  case   59: return "v**2";
  case   60: return "Product of wind components  u*v";
  case   61: return "x component of wind stress";
  case   62: return "y component of wind stress";
  case   63: return "Kinetic energy";
  case   64: return "Wind in DDDFFF format";
  case   65: return "Hybrid height";
  case   66: return "Reserved for M.Mawson";
  case   67: return "Reserved for M.Mawson";
  case   68: return "u-acceleration from saturated stress";
  case   69: return "v-acceleration from saturated stress";
  case   70: return "u-acceleration from hydraulic jump";
  case   71: return "v-acceleration from hydraulic jump";
  case   72: return "Absolute vorticity";
  case   73: return "Relative vorticity";
  case   74: return "Divergence";
  case   75: return "Height of base of lowest cloud in feet";
  case   76: return "Height of top of lowest cloud in feet";
  case   77: return "Total precipitation accumulation";
  case   78: return "QCF - Frozen cloud water";
  case   79: return "QCL - Liquid cloud water";
  case   80: return "Stream function";
  case   81: return "Velocity potential";
  case   82: return "Ertel potential vorticity (Q)";
  case   83: return "Thermal vorticity";
  case   84: return "Quasi-geostrophic potential vorticity";
  case   85: return "Montgomery stream function";
  case   86: return "Geostrophic absolute vorticity";
  case   87: return "dq/dt";
  case   88: return "Relative humidity";
  case   89: return "Precipitable water";
  case   90: return "Total precipitation rate";
  case   91: return "Equivalent ice depth";
  case   92: return "Actual ice depth";
  case   93: return "Snow depth (water equivalent)";
  case   94: return "Convective rain";
  case   95: return "Specific humidity q";
  case   96: return "Condensed water (per unit area)";
  case   97: return "Total rainfall rate";
  case   98: return "Convective rainfall rate";
  case   99: return "Dynamic rainfall rate";
  case  100: return "Local convective rainfall";
  case  101: return "Mixing ratio";
  case  102: return "Large scale rain";
  case  103: return "Snow";
  case  104: return "Total rain";
  case  105: return "Evaporation";
  case  106: return "Total soil moisture content (levels 1-4)";
  case  107: return "Sublimation";
  case  108: return "Snowfall rate";
  case  109: return "Total runoff";
  case  110: return "Snowmelt";
  case  111: return "Quick runoff";
  case  112: return "Slow runoff";
  case  113: return "(Precipitation minus evaporation) rate";
  case  114: return "Evaporation rate";
  case  115: return "Evaporation from soil surface";
  case  116: return "Large scale snowfall";
  case  117: return "Convective snowfall";
  case  118: return "Large scale snowfall rate mm/s";
  case  119: return "Convective snowfall rate mm/s";
  case  120: return "Total large-scale precipitation";
  case  121: return "Total convective precipitation";
  case  122: return "Soil moisture in each (of 4) levels";
  case  123: return "u-acceleration from trapped lee waves";
  case  124: return "v-acceleration from trapped lee waves";
  case  125: return "Vertical transmission coefficient";
  case  126: return "Max C.A.T. level";
  case  127: return "Sea bed level";
  case  128: return "Mean sea level";
  case  129: return "Surface";
  case  130: return "Tropopause level";
  case  131: return "Maximum wind level";
  case  132: return "Freezing level";
  case  133: return "Top of atmosphere";
  case  134: return "-20 deg.C level";
  case  135: return "Upper level (height)";
  case  136: return "Lower level (height)";
  case  137: return "Upper level (pressure)";
  case  138: return "Lower level (pressure)";
  case  139: return "Wet bulb freezing level height (asl)";
  case  140: return "Salinity";
  case  141: return "Snowmelt heat flux";
  case  142: return "Upper level (hybrid)";
  case  143: return "Lower level (hybrid)";
  case  144: return "Unified model test diagnostic for output no. 1";
  case  145: return "Unified model test diagnostic for output no. 2";
  case  146: return "Unified model test diagnostic for output no. 3";
  case  147: return "Unified model test diagnostic for output no. 4";
  case  148: return "X component of geostrophic wind";
  case  149: return "Y component of geostrophic wind";
  case  150: return "Standard deviation of orography";
  case  151: return "Distance to the centre of the earth";
  case  152: return "Orography XX gradient component";
  case  153: return "Orography XY gradient component";
  case  154: return "Orography YY gradient component";
  case  155: return "Orographic roughness";
  case  156: return "Total ozone climatology";
  case  157: return "Ultra violet index climatology";
  case  158: return "Total ozone field, Dobson units";
  case  159: return "UVB (Ultra violet index - dimensionless)";
  case  160: return "Drag coefficient CD";
  case  161: return "Theta_e";
  case  162: return "Sunshine hours";
  case  163: return "Convective cloud liquid re * convective cloud amount";
  case  164: return "Layer cloud liquid re * layer cloud amount";
  case  165: return "Convective cloud amount in SWRAD (microphysics)";
  case  166: return "Layer cloud amount in SWRAD (microphysics)";
  case  167: return "Layer cloud condensed water path * amount";
  case  168: return "Cloud emissivity * cloud fraction";
  case  169: return "Cloud albedo * cloud fraction";
  case  170: return "Transmissivity";
  case  171: return "RHOKH (RHO* * CH * SURF_LAYER_WIND_SHEAR)";
  case  172: return "RHOKM (RHO* * CD * SURF_LAYER_WIND_SHEAR)";
  case  173: return "Probability of visibility less than 5 km";
  case  174: return "Silhouette area of unresolved orography per unit horizontal area";
  case  175: return "Peak to trough height of unresolved orography divided by 2";
  case  176: return "Latitude  (north positive)";
  case  177: return "Longitude  (east positive)";
  case  178: return "Sensible heat flux";
  case  179: return "Soil heat flux";
  case  180: return "Latent heat flux";
  case  181: return "Bulk Richardson number";
  case  182: return "Wind mixing energy";
  case  183: return "CH - bulk transfer coefficient of heat";
  case  184: return "Moisture flux";
  case  185: return "Mass flux";
  case  186: return "Net short wave radiation flux";
  case  187: return "Net long wave radiation flux";
  case  188: return "Total surface heat flux (inc. sensible+latent)";
  case  189: return "Thermal advection";
  case  190: return "C.A.T. probability";
  case  191: return "Snow probability";
  case  192: return "Boundary mixing coeffs.";
  case  193: return "Convective heating rate";
  case  194: return "Convective moistening rate";
  case  195: return "Vertical momentum flux - U";
  case  196: return "Vertical momentum flux - V";
  case  197: return "Snow melt heating flux";
  case  198: return "Evaporation duct height";
  case  199: return "Evap. duct intensity (max wavelength trapped)";
  case  200: return "Downward solar";
  case  201: return "Upward solar";
  case  202: return "Net surface radiation flux (No sensible or latent)";
  case  203: return "Total downward surface solar flux over sea-ice.";
  case  204: return "Reserved for M.Mawson";
  case  205: return "IR down";
  case  206: return "IR up";
  case  207: return "Clear-sky flux (type II) solar up";
  case  208: return "Clear-sky flux (type II) solar down";
  case  209: return "Sea-ice temperature";
  case  210: return "Clear-sky (type II) IR up";
  case  211: return "Clear-sky (type II) IR down";
  case  212: return "Convective cloud base times amount";
  case  213: return "Dilute convectively available potential energy";
  case  214: return "Clear-sky (type II) net shortwave flux";
  case  215: return "Clear-sky (type II) net longwave flux";
  case  216: return "Cloud top height (asl)";
  case  217: return "Convective cloud top times amount";
  case  218: return "Convective cloud water";
  case  219: return "Convective cloud condensed water path";
  case  220: return "Cloud amount in a layer / at a level";
  case  221: return "Total water condensed by convection";
  case  222: return "Convective cloud base level-number";
  case  223: return "Convective cloud top level-number";
  case  224: return "Advecting u * layer thickness (pascals) = zonal mass-flux";
  case  225: return "Advecting v * layer thickness (pascals) = meridional mass-flux";
  case  226: return "Blocking index (Tibaldi & Molteni definition)";
  case  227: return "EMAX from convection scheme";
  case  228: return "Total net radiative heating";
  case  229: return "Zonal mass-flux * temperature";
  case  230: return "Meridional mass-flux * temperature";
  case  231: return "Zonal mass-flux * specific humidity q";
  case  232: return "Meridional mass-flux * specific humidity q";
  case  233: return "Zonal mass-flux * liquid water temperature";
  case  234: return "Meridional mass-flux * liquid water temperature";
  case  235: return "Zonal mass-flux * total water";
  case  236: return "Meridional mass-flux * total water";
  case  237: return "Clear-sky (type I) solar up";
  case  238: return "Clear-sky (type I) solar down";
  case  239: return "Vapour pressure";
  case  240: return "Clear-sky (type I) IR up";
  case  241: return "Clear-sky (type I) IR down";
  case  242: return "Probability of precipitation";
  case  243: return "Clear-sky (type I) net shortwave flux";
  case  244: return "Clear-sky (type I) net longwave flux";
  case  245: return "Clear-sky(type I) radiative heating";
  case  246: return "Clear-sky(type I) short-wave radiative heating";
  case  247: return "Clear-sky(type I) long wave radiative heating";
  case  248: return "X component of ageostrophic wind";
  case  249: return "Y component of ageostrophic wind";
  case  250: return "Clear-sky(type II) radiative heating";
  case  251: return "Short-wave radiative heating";
  case  252: return "Clear-sky(type II) short-wave radiative heating";
  case  253: return "Long-wave radiative heating";
  case  254: return "Clear-sky(type II) long-wave radiative heating";
  case  255: return "Convective cloud liquid re * convective cloud weighting (full levels)";
  case  256: return "Convective cloud weighting for microphysics (full levels)";
  case  257: return "RHO_CD_MODV1 = rhostar*cD*modv1";
  case  258: return "RHO_KM = rho*Km (Km = turbulent mixing coefficient for momentum)";
  case  259: return "Atmospheric energy correction (from UM 3.3)";
  case  260: return "Sea-ice topmelt";
  case  261: return "Sea-ice botmelt";
  case  262: return "Fractional time of change of ice cover.";
  case  263: return "Zonal mass-flux * u";
  case  264: return "Meridional mass-flux * u";
  case  265: return "Zonal mass-flux * v";
  case  266: return "Meridional mass-flux * v";
  case  267: return "Zonal mass-flux * geopotential";
  case  268: return "Meridional mass-flux * geopotential";
  case  269: return "Zonal mass-flux * moist static energy";
  case  270: return "Meridional mass-flux * moist static energy";
  case  271: return "Canopy water content";
  case  272: return "Canopy condensation";
  case  273: return "Canopy evaporation";
  case  274: return "Canopy water throughfall";
  case  275: return "Canopy height (all vegetation)";
  case  276: return "Air concentration of radioactivity";
  case  277: return "Dosage of radioactivity";
  case  278: return "Dry deposition of radioactivity";
  case  279: return "Wet deposition of radioactivity";
  case  280: return "Leads;net solar radiation";
  case  281: return "Leads;net infra-red flux";
  case  282: return "Leads;sensible heat flux";
  case  283: return "Leads;latent heat flux";
  case  284: return "Total deposition of radioactivity";
  case  285: return "Evap from sea * leads fraction.";
  case  286: return "Total aerosol";
  case  287: return "Total aerosol emissions";
  case  288: return "Visibility assimilation weights";
  case  289: return "Visibility assimilation increment";
  case  290: return "P* (surface pressure) weights";
  case  291: return "Theta weights";
  case  292: return "Wind weights";
  case  293: return "Surface wind weights.......";
  case  294: return "RH weights";
  case  295: return "Precipitation rate assimilation weights";
  case  296: return "Spare for A/C";
  case  297: return "Spare for A/C";
  case  298: return "Spare for A/C";
  case  299: return "Specific layer cloud water content";
  case  300: return "Spare for A/C";
  case  301: return "Spare for A/C";
  case  302: return "Spare for A/C";
  case  303: return "P* (surface pressure) assimilation increments";
  case  304: return "Theta assimilation increments";
  case  305: return "u assimilation increments";
  case  306: return "v assimilation increments";
  case  307: return "Hydrostatic increments";
  case  308: return "Probability of ground frost";
  case  309: return "RH assimilation increments";
  case  310: return "Precipitation rate assimilation increments";
  case  311: return "Reserved for M.Mawson";
  case  312: return "Reserved for M.Mawson";
  case  313: return "Reserved for M.Mawson";
  case  314: return "Reserved for M.Mawson";
  case  315: return "Increment in q from a routine";
  case  316: return "Increment in T from a routine";
  case  317: return "Increment in theta from a routine";
  case  318: return "Increment in u from a routine";
  case  319: return "Increment in v from a routine";
  case  320: return "Surface roughness (heat)";
  case  321: return "Root depth";
  case  322: return "Snow free albedo (all types of land)";
  case  323: return "Surface resistance to evaporation";
  case  324: return "Surface roughness (momentum)";
  case  325: return "Surface capacity";
  case  326: return "Vegetation fraction";
  case  327: return "Veg. infilt. enhancement factor";
  case  328: return "Deep snow albedo";
  case  329: return "Wilting point";
  case  330: return "Critical point";
  case  331: return "Field capacity";
  case  332: return "Saturation";
  case  333: return "Saturated conductivity";
  case  334: return "Eagleson's exponent";
  case  335: return "Heat capacity";
  case  336: return "Heat conductivity";
  case  337: return "SOILB (Soil hydrology parameter BS)";
  case  338: return "Field capacity-root depth";
  case  339: return "Surface infilt.-infilt. factor";
  case  340: return "Thermal inertia-(lambda C ** 1/2)";
  case  341: return "Veg. infilt. enhancement factor * Saturated conductivity";
  case  342: return "Saturated soil water suction";
  case  343: return "Lowest convective cloud amount";
  case  344: return "Lowest convective cloud base";
  case  345: return "Lowest convective cloud top";
  case  346: return "Lowest convective cloud base";
  case  347: return "Lowest convective cloud top";
  case  348: return "X component of Q";
  case  349: return "Y component of Q";
  case  350: return "DIV(Q)";
  case  351: return "Wave/ Spectral wave energy component";
  case  366: return "Wave/ Induced stress";
  case  367: return "Wave/ Dependent roughness length";
  case  368: return "Wave/ Total induced current speed";
  case  369: return "Wave/ Total induced current direction";
  case  370: return "Wave/ Surge induced current speed";
  case  371: return "Wave/ Surge induced current direction";
  case  372: return "Wave/ Tide induced water level";
  case  373: return "Wave/ Tide induced current speed";
  case  374: return "Wave/ Tide induced current direction";
  case  375: return "Wave/ Mean wave height error";
  case  376: return "Wave/ Mean wave period error";
  case  377: return "Wave/ Mean wave speed error";
  case  378: return "Wave/ RMS wave height error";
  case  379: return "Wave/ RMS wave period error";
  case  380: return "Wave/ RMS wave speed error";
  case  384: return "Wave/ Water temperature";
  case  385: return "Wave/ Height of wind-driven waves";
  case  386: return "Wave/ Height of sea swells";
  case  387: return "Wave/ Combined wave and swell height";
  case  388: return "Wave/ Period of wind-driven waves";
  case  389: return "Wave/ Direction from which waves come";
  case  390: return "Wave/ Period of sea swells";
  case  391: return "Wave/ Direction from which swells come";
  case  392: return "Wave/ Total depth (wave+surge)";
  case  393: return "Wave/ Period of significant waves";
  case  394: return "Wave/ Dirn. from which sig. waves come";
  case  395: return "Wave/ Grid point type (sea/land/coast)";
  case  396: return "Wave/ Surge induced water level";
  case  397: return "Wave/ Wave model land/sea indicator";
  case  401: return "MA/ d(ln p)/dt";
  case  402: return "MA/ d(theta)/dp";
  case  403: return "MA/ Log(Absolute ertel pot. vorticity)";
  case  404: return "MA/ Sign of dq/dt";
  case  405: return "MA/ d(theta)/dt";
  case  406: return "MA/ Shortwave heating rates";
  case  407: return "MA/ Longwave cooling rates";
  case  408: return "MA/ Total radiative heating";
  case  409: return "MA/ Friction term in circulation budget";
  case  410: return "MA/ dp/d(theta)";
  case  411: return "MA/ Geostrophic Ertel potential vorticity";
  case  412: return "MA/ dq/dt advection term";
  case  413: return "MA/ dq/dt source term";
  case  414: return "MA/ Total dq/dt ie source + advection";
  case  415: return "MA/ d(theta)/dt";
  case  416: return "MA/ Absolute vorticity (interpolated)";
  case  417: return "MA/ Absolute vorticity*total dq/dt";
  case  418: return "MA/ dq/dt from Raleigh friction";
  case  451: return "MAtr/ Passive tracer";
  case  452: return "MAtr/ Nitrous oxide tracer";
  case  453: return "MAtr/ Ozone tracer";
  case  501: return "MAUA/ Atmosphere tracer 1 (conventionally O3)";
  case  502: return "MAUA/ Atmosphere tracer 2 (conventionally H2O)";
  case  503: return "MAUA/ Atmosphere tracer 3 (conventionally CO)";
  case  504: return "MAUA/ Atmosphere tracer 4 (conventionally CH4)";
  case  505: return "MAUA/ Atmosphere tracer 5 (conventionally N2O)";
  case  506: return "MAUA/ Atmosphere tracer 6 (conventionally NO)";
  case  507: return "MAUA/ Atmosphere tracer 7 (conventionally NO2)";
  case  508: return "MAUA/ Atmosphere tracer 8 (conventionally HNO3)";
  case  509: return "MAUA/ Atmosphere tracer 9 (conventionally N2O5)";
  case  510: return "MAUA/ Atmosphere tracer 10 (conventionally ClONO2)";
  case  511: return "MAUA/ Atmosphere tracer 11 (conventionally ClO)";
  case  512: return "MAUA/ Atmosphere tracer 12 (conventionally HCl)";
  case  513: return "MAUA/ Atmosphere tracer 13 (conventionally CF2Cl2)";
  case  514: return "MAUA/ Atmosphere tracer 14 (conventionally CFCl3)";
  case  515: return "MAUA/ Atmosphere tracer 15 (conventionally HF)";
  case  516: return "MAUA/ Atmosphere tracer 16";
  case  517: return "MAUA/ Atmosphere tracer 17";
  case  518: return "MAUA/ Atmosphere tracer 18";
  case  519: return "MAUA/ Atmosphere tracer 19 (conventionally SO2)";
  case  520: return "MAUA/ Atmosphere tracer 20 (conventionally DMS)";
  case  521: return "MAUA/ Atmosphere tracer 21 (conventionally H2S)";
  case  522: return "MAUA/ Atmosphere tracer 22 (conventionally WATER-SOLUBLE)";
  case  523: return "MAUA/ Atmosphere tracer 23 (conventionally DUST-LIKE)";
  case  524: return "MAUA/ Atmosphere tracer 24 (conventionally OCEANIC)";
  case  525: return "MAUA/ Atmosphere tracer 25 (conventionally SOOT)";
  case  526: return "MAUA/ Atmosphere tracer 26 (conventionally VOLCANIC ASH)";
  case  527: return "MAUA/ Atmosphere tracer 27 (conventionally SULPHURIC ACID)";
  case  528: return "MAUA/ Atmosphere tracer 28 (conventionally AMMONIUM SULPHATE)";
  case  529: return "MAUA/ Atmosphere tracer 29 (conventionally MINERAL)";
  case  569: return "MAUA/ Sulphur Dioxide emissions.";
  case  570: return "MAUA/ Dimethyl Sulphide emissions.";
  case  571: return "MAUA/ Hydrogen Sulphide emissions.";
  case  572: return "MAUA/ NH3 gas emissions";
  case  573: return "MAUA/ Soot emissions";
  case  580: return "MAUA/ Hydroxyl radical concentration molecules";
  case  581: return "MAUA/ Hydrogen Peroxide concentration";
  case  600: return "MAUA/ HO2 concentration";
  case  601: return "OCtr/ Temperature.";
  case  602: return "OCtr/ Salinity.";
  case  603: return "OCtr/ T*";
  case  604: return "OCtr/ Temperature at t-1.";
  case  605: return "OCtr/ Salinity at t-1.";
  case  606: return "OCtr/ No. deep convection points";
  case  607: return "OCtr/ Fractional expansion of sea water (dimensionless)";
  case  608: return "OCtr/ Sea surface elevation";
  case  609: return "OCtr/ Density of sea water";
  case  610: return "OCtr/ Sea level rise";
  case  611: return "OCtr/ Stream function.";
  case  612: return "OCtr/ Stream function at t-1.";
  case  613: return "OCtr/ Change of stream function across a time step.";
  case  614: return "OCtr/ Change of stream function across previous timestep.";
  case  615: return "OCtr/ (Formerly reciprocal of total depth at U/V points, use 715 1/1/92)";
  case  616: return "OCtr/ Number of vertical levels of ocean at T points.";
  case  617: return "Octr/ rigid-lid pressure";
  case  618: return "OCtr/ Change of vorticity across one timestep.";
  case  619: return "OCtr/ Vertical expansion of sea water.";
  case  620: return "OCtr/ Convergence heat";
  case  621: return "OCtr/ Equivalent ice depth.";
  case  622: return "OCtr/ Snow depth.";
  case  623: return "OCtr/ Snowfall.";
  case  624: return "OCtr/ Sublimation.";
  case  625: return "OCtr/ Net solar heat flux.";
  case  626: return "OCtr/ Net surface heat flux (HTN).";
  case  627: return "OCtr/ Wind mixing energy.";
  case  628: return "OCtr/ Diffusive heat flux.";
  case  629: return "OCtr/ Precipitation minus evaporation (PLE)";
  case  630: return "OCtr/ Sum of net solar and net surface heating.";
  case  631: return "OCtr/ River outflow";
  case  632: return "OCtr/ Surface water flux * salinity / density";
  case  633: return "OCtr/ x component of sea-ice/ocean surface stress (ISX)";
  case  634: return "OCtr/ y component of sea-ice/ocean surface stress (ISY)";
  case  635: return "OCtr/ Buoyancy";
  case  636: return "OCtr/ Buoyancy flux";
  case  637: return "OCtr/ In-situ temperature";
  case  638: return "OCtr/ sigma-T/kg m**-3 ( (rho(insitu_T,S,0)-1000 )";
  case  639: return "OCtr/ sigma-theta/kg m**-3 ( rho(theta,S,0)-1000 )";
  case  640: return "OCtr/ Zonal heat advection.";
  case  641: return "OCtr/ Meridional heat advection.";
  case  642: return "OCtr/ Heating rate due to advection";
  case  643: return "OCtr/ Heating rate due to diffusion ";
  case  644: return "OCtr/ Heating rate due to surface fluxes";
  case  645: return "OCtr/ Heating rate due to mixing";
  case  646: return "OCtr/ Heating rate due to filtering";
  case  647: return "OCtr/ Heating rate";
  case  648: return "OCtr/ Rate of change of salinity (UM cant control LBPROC)";
  case  649: return "OCtr/ Climatological reference surface salinity";
  case  650: return "OCtr/ Climatological reference SST (sea surface temperature).";
  case  651: return "OCtr/ Anomalous heat flux from Haney term.";
  case  652: return "OCtr/ Anomalous latent heat flux from Haney term";
  case  653: return "OCtr/ Mixed layer depth,type 1.";
  case  654: return "OCtr/ Mixed layer depth,type 2.";
  case  655: return "OCtr/ Heat content";
  case  656: return "OCtr/ Latent heat content";
  case  657: return "OCtr/ Turbulent kinetic energy";
  case  658: return "OCtr/ Thickness diff coeff (ocean)";
  case  660: return "OCtr/ Vertical mean vorticity forcing: advection";
  case  661: return "OCtr/ Vertical mean vorticity forcing: hor diffn";
  case  662: return "OCtr/ Vertical mean vorticity forcing: vrt diffn";
  case  663: return "OCtr/ Vertical mean vorticity forcing: coriolis";
  case  664: return "OCtr/ Vertical mean vorticity forcing: pressure";
  case  665: return "OCtr/ Vertical integral vorticity forcing: advection";
  case  666: return "OCtr/ Vertical integral vorticity forcing: hor diffn";
  case  667: return "OCtr/ Vertical integral vorticity forcing: vrt diffn";
  case  668: return "OCtr/ Vertical integral vorticity forcing: coriolis";
  case  669: return "OCtr/ Vertical integral vorticity forcing: bottom p";
  case  670: return "OCtr/ Boundary profiles.";
  case  671: return "OCtr/ Anomalous heat flux.";
  case  672: return "OCtr/ Anomalous salt flux.";
  case  673: return "OCtr/ Virtual air-sea flux of co2";
  case  674: return "OCtr/ Virtual air-sea flux of alkalinity";
  case  675: return "OCtr/ Climatological Ice depth";
  case  676: return "OCtr/ Mass of ocean below rigid lid";
  case  677: return "OCtr/ Ocean bottom pressure";
  case  678: return "OCtr/ Anomolous sea-ice heat flux";
  case  679: return "OCtr/ Anomalous sea-ice P-E flux";
  case  680: return "OCtr/ W (vertical velocity).";
  case  681: return "OCtr/ Topmelt.";
  case  682: return "OCtr/ Botmelt.";
  case  683: return "OCtr/ Fractional ice cover.";
  case  684: return "OCtr/ Ocean-ice heat flux.";
  case  685: return "OCtr/ Carry heat.";
  case  686: return "OCtr/ Carry salt.";
  case  687: return "OCtr/ Actual ice depth.";
  case  688: return "OCtr/ Snow depth over ice.";
  case  689: return "OCtr/ Sea-ice internal pressure";
  case  690: return "OCtr/ Sea-ice strength";
  case  692: return "OCtr/ Average snow depth.";
  case  693: return "OCtr/ Average ice cover.";
  case  694: return "OCtr/ Average O/I heat flux.";
  case  695: return "OCtr/ KT Vertical tracer diffusion coeff";
  case  696: return "OCtr/ RiT Richardson no tracer";
  case  697: return "OCtr/ HT Max depth Large scheme tracer";
  case  698: return "OCtr/ Downwards solar radiation over ice";
  case  699: return "OCtr/ Depth of ocean at TS points";
  case  700: return "OCuv/ River run-off ocean entry point co-ordinates.";
  case  701: return "OCuv/ Baroclinic component of zonal velocity";
  case  702: return "OCuv/ Baroclinic component of meridional velocity";
  case  703: return "OCuv/ Zonal velocity (total)";
  case  704: return "OCuv/ Meridional velocity (total)";
  case  711: return "OCuv/ Barotropic component of zonal velocity";
  case  712: return "OCuv/ Barotropic component of meridional velocity";
  case  713: return "OCuv/ Baroclinic x-acceleration";
  case  714: return "OCuv/ Baroclinic y-acceleration";
  case  715: return "OCuv/ Reciprocal of total depth";
  case  717: return "OCuv/ Number of vertical levels of ocean at U/V points.";
  case  718: return "OCuv/ Vertical integral of zonal velocity";
  case  719: return "OCuv/ Vertical integral of meridional velocity";
  case  721: return "OCuv/ Zonal component of windstress (TAUX)";
  case  722: return "OCuv/ Meridional component of windstress (TAUY)";
  case  728: return "OCuv/ x component of sea-ice velocity";
  case  729: return "OCuv/ y component of sea-ice velocity";
  case  730: return "OCuv/ Magnitude of sea-ice velocity";
  case  731: return "OCuv/ Zonal component of sea-ice velocity";
  case  732: return "OCuv/ Meridional component of sea-ice velocity";
  case  733: return "OCuv/ Zonal component of ice-ocean stress";
  case  734: return "OCuv/ Meridional component of ice-ocean stress";
  case  735: return "OCuv/ Zonal component of Coriolis stress";
  case  736: return "OCuv/ Meridional component of Coriolis stress";
  case  737: return "OCuv/ Zonal component of internal ice stress";
  case  738: return "OCuv/ Meridional component of internal ice stress";
  case  740: return "OCuv/ Zonal mean tracer transport diagnostics";
  case  741: return "OCuv/ Baroclinic acceleration diag, meridional: Advection";
  case  742: return "OCuv/ Baroclinic acceleration diag, meridional: Hor Diffusion";
  case  743: return "OCuv/ Baroclinic acceleration diag, meridional: Vert Diffusion";
  case  744: return "OCuv/ Baroclinic acceleration diag, meridional: Coriolis";
  case  745: return "OCuv/ Baroclinic acceleration diag, meridional: Pressure";
  case  746: return "OCuv/ Baroclinic acceleration diag, zonal: Advection";
  case  747: return "OCuv/ Baroclinic acceleration diag, zonal: Hor Diffusion";
  case  748: return "OCuv/ Baroclinic acceleration diag, zonal: Vert Diffusion";
  case  749: return "OCuv/ Baroclinic acceleration diag, zonal: Coriolis";
  case  750: return "OCuv/ Baroclinic acceleration diag, zonal: Pressure";
  case  751: return "OCuv/ Meridional net pressure gradient";
  case  752: return "OCuv/ Zonal net pressure gradient";
  case  753: return "OCuv/ Meridional acceleration";
  case  754: return "OCuv/ Zonal acceleration";
  case  795: return "OCuv/ KM Vertical momentum diffusion coeff";
  case  796: return "OCuv/ RiM Richardson no momentum";
  case  797: return "OCuv/ HM Max depth Large scheme momentum";
  case  801: return "OCE/  ocean extra tracer 1 (conventionally TCO2 )";
  case  802: return "OCE/  ocean extra tracer 2 (conventionally alkalinity)";
  case  803: return "OCE/  ocean extra tracer 3 (conventionally nutrient)";
  case  804: return "OCE/  ocean extra tracer 4 (conventionally phytoplankton conc.)";
  case  805: return "OCE/  ocean extra tracer 5 (conventionally zooplankton)";
  case  806: return "OCE/  ocean extra tracer 6 (conventionally detritus)";
  case  807: return "OCE/  ocean extra tracer 7 (conventionally tritium)";
  case  808: return "OCE/  ocean extra tracer 8 (conventionally 3H+3He total mass)";
  case  809: return "OCE/  ocean extra tracer 9 (conventionally CFC11)";
  case  810: return "OCE/  ocean extra tracer 10 (conventionally CFC12)";
  case  811: return "OCE/  ocean extra tracer 11 (conventionally CFC13)";
  case  812: return "OCE/  ocean extra tracer 12 (conventionally carbon 14)";
  case  813: return "OCE/  ocean extra tracer 13";
  case  814: return "OCE/  ocean extra tracer 14";
  case  815: return "OCE/  ocean extra tracer 15";
  case  816: return "OCE/  ocean extra tracer 16";
  case  817: return "OCE/  ocean extra tracer 17";
  case  818: return "OCE/  ocean extra tracer 18";
  case  820: return "OCE/ Sonic layer depth";
  case  821: return "OCE/ Sonic layer trap at 10Hz (0/1)";
  case  822: return "OCE/ Sonic layer trap at 50Hz (0/1)";
  case  823: return "OCE/ Sonic layer trap at 1kHz (0/1)";
  case  824: return "OCE/ Sonic layer trap at 10kHz (0/1)";
  case  825: return "OCE/ Sound channel strength at 10Hz (1-3)";
  case  826: return "OCE/ Sound channel strength at 50Hz (1-3)";
  case  827: return "OCE/ Sound channel strength at 1kHz (1-3)";
  case  828: return "OCE/ Sound channel strength at 10kHz (1-3)";
  case  829: return "OCE/ Range to the 1st CZ";
  case  830: return "OCE/ Strength of 1st CZ (0-100)";
  case  831: return "OCE/ Gent and McWilliams scheme eddy u velocity (ocean)";
  case  832: return "OCE/ Gent and McWilliams scheme eddy v velocity (N face) (ocean)";
  case  833: return "OCE/ Gent and McWilliams scheme eddy w velocity (top face) (ocean)";
  case  834: return "OCE/ d theta/dt from Gent and McWilliams scheme";
  case  835: return "OCE/ Speed of sound in water";
  case  836: return "OCE/ Depth of sound speed minimum (sound channel)";
  case  837: return "OCE/ Depth of max neg ssp grad";
  case  838: return "OCE/ CO2 atmosphere level 1 conc";
  case  840: return "OCE/ Total temperature advection, zonal.";
  case  841: return "OCE/ Total temperature diffusion, zonal.";
  case  850: return "OA/ Surface height analysis weights";
  case  851: return "OA/ Mixed layer depth analysis weights";
  case  852: return "OA/ Surface temperature analysis weights";
  case  853: return "OA/ Potential temperature analysis weights";
  case  854: return "OA/ Salinity analysis weights";
  case  855: return "OA/ Velocity components analysis weights";
  case  860: return "OA/ Surface height analysis increments";
  case  861: return "OA/ Mixed layer depth analysis increments";
  case  862: return "OA/ Surface temperature analysis increments";
  case  863: return "OA/ Potential temperature analysis increments";
  case  864: return "OA/ Salinity analysis increments";
  case  865: return "OA/ Zonal velocity analysis increments";
  case  870: return "OA/ Meridional velocity analysis increments";
  case  871: return "OA/ Meridional velocity increments after surface height analysis";
  case  872: return "OA/ Meridional velocity increments after thermal analysis";
  case  873: return "OA/ Meridional velocity increments after saline analysis";
  case  876: return "OA/ Zonal velocity increments after surface height analysis";
  case  877: return "OA/ Zonal velocity increments after thermal analysis";
  case  878: return "OA/ Zonal velocity increments after saline analysis";
  case  880: return "OA/ Pressure increments after surface height analysis";
  case  881: return "OA/ Pressure increments after thermal analysis";
  case  882: return "OA/ Pressure increments after saline analysis";
  case  885: return "OA/ Potential temperature increments after surface height analysis";
  case  888: return "OA/ Saline increments after surface height analysis";
  case  891: return "OCE/ PRIMARY PRODUCTION (GC/M2/DAY)";
  case  892: return "OCE/ ZOOPLTN PRODUCTION (GC/M2/DAY)";
  case  893: return "OCE/ PHYTO SPECIFIC GROWTH RATE (1/DAY)";
  case  894: return "OCE/ PHYTO SPECIFIC GRAZING RATE (1/DAY)";
  case  895: return "OCE/ PHYTO SPECIFIC MORTALITY (1/DAY)";
  case  896: return "OCE/ NITRATE GAIN-EXCRETION (MMOL-N/M2/D)";
  case  897: return "OCE/ NITRATE LOSS - GROWTH (MMOL-N/M2/D)";
  case  898: return "OCE/ NITRATE GAIN-PHY MORT (MMOL-N/M2/D)";
  case  899: return "OCE/ NITRATE GAIN-ZOO MORT (MMOL-N/M2/D)";
  case  900: return "OCE/ NITRATE GAIN-PHY RESP (MMOL-N/M2/D)";
  case  901: return "OCE/ NITRATE GAIN-REMIN    (MMOL-N/M2/D)";
  case  902: return "OCE/ NUTRIENT LIMITATION";
  case  903: return "OCE/ LIGHT LIMITATION";
  case  904: return "OCE/ TEMPERATURE LIMITATION";
  case  905: return "OCE/ DETRITUS FLUX  (MMOL-N/M2/D)";
  case  906: return "OCE/ VERTICAL NITRATE FLUX  (MMOL-N/M2/D)";
  case  907: return "OCE/ HORIZ NITRATE ADVECT RATE(MMOL/M3/D)";
  case  908: return "OCE/ VERT NITRATE ADVECTN RATE(MMOL/M3/D)";
  case  909: return "OCE/ HORIZ NITRATE DIFFUSION  (MMOL/M3/D)";
  case  910: return "OCE/ VERT NITRATE DIFFUSION   (MMOL/M3/D)";
  case  911: return "OCE/ NITRATE MIXING DUE TO MLM(MMOL/M3/D)";
  case  912: return "OCE/ NITRATE CONVECTION       (MMOL/M3/D)";
  case  913: return "OCE/ NITRATE CHANGE - BIOLOGY (MMOL/M3/D)";
  case  914: return "OCE/ NITRATE CHANGE-RESETTING (MMOL/M3/D)";
  case  915: return "OCE/ HORIZ PHYTO ADVECT RATE(MMOL-N/M3/D)";
  case  916: return "OCE/ HORIZ ZOO   ADVECT RATE(MMOL-N/M3/D)";
  case  917: return "OCE/ HORIZ DETRI ADVECT RATE(MMOL-N/M3/D)";
  case  918: return "OCE/ Rate of change of sea-ice concentration";
  case  919: return "OCE/ Rate of change of sea-ice depth";
  case  920: return "OCE/ Rate of change of snowdepth on sea-ice";
  case  940: return "OCE/ Total temperature advection, meridional.";
  case  941: return "OCE/ Total temperature diffusion, meridional.";
  case  942: return "OCE/ Mmeridional overturning streamfunction/Sv";
  case 1301: return "BL flux of atmospheric tracer  1 (conventionally O3)";
  case 1302: return "BL flux of atmospheric tracer  2 (conventionally H2O)";
  case 1303: return "BL flux of atmospheric tracer  3 (conventionally CO)";
  case 1304: return "BL flux of atmospheric tracer  4 (conventionally CH4)";
  case 1305: return "BL flux of atmospheric tracer  5 (conventionally N2O)";
  case 1306: return "BL flux of atmospheric tracer  6 (conventionally NO)";
  case 1307: return "BL flux of atmospheric tracer  7 (conventionally NO2)";
  case 1308: return "BL flux of atmospheric tracer  8 (conventionally HNO3)";
  case 1309: return "BL flux of atmospheric tracer  9 (conventionally N2O5)";
  case 1310: return "BL flux of atmospheric tracer 10 (conventionally ClONO2)";
  case 1311: return "BL flux of atmospheric tracer 11 (conventionally ClO)";
  case 1312: return "BL flux of atmospheric tracer 12 (conventionally HCl)";
  case 1313: return "BL flux of atmospheric tracer 13 (conventionally CF2Cl2)";
  case 1314: return "BL flux of atmospheric tracer 14 (conventionally CFCl3)";
  case 1315: return "BL flux of atmospheric tracer 15 (conventionally HF)";
  case 1316: return "BL flux of atmospheric tracer 16";
  case 1317: return "BL flux of atmospheric tracer 17";
  case 1318: return "BL flux of atmospheric tracer 18";
  case 1319: return "BL flux of atmospheric tracer 19 (conventionally SO2)";
  case 1320: return "BL flux of atmospheric tracer 20 (conventionally DMS)";
  case 1321: return "BL flux of atmospheric tracer 21 (conventionally H2S)";
  case 1322: return "BL flux of atmospheric tracer 22 (conventionally WATER-SOLUBLE)";
  case 1323: return "BL flux of atmospheric tracer 23 (conventionally DUST-LIKE)";
  case 1324: return "BL flux of atmospheric tracer 24 (conventionally OCEANIC)";
  case 1325: return "BL flux of atmospheric tracer 25 (conventionally SOOT)";
  case 1326: return "BL flux of atmospheric tracer 26 (conventionally VOLCANIC ASH)";
  case 1327: return "BL flux of atmospheric tracer 27 (conventionally SULPHURIC ACID)";
  case 1328: return "BL flux of atmospheric tracer 28 (conventionally AMMONIUM SULPHATE)";
  case 1329: return "BL flux of atmospheric tracer 29 (conventionally MINERAL)";
  case 1330: return "BL flux of atmospheric total aerosol";
  case 1332: return "Ice Possible (0- -20 Celcius, RH =>70%) 1.0=possible;0.0 not";
  case 1333: return "Liquid water in any region averaged during all-sky conditions";
  case 1334: return "q*w  (specific humidity * vertical velocity)";
  case 1335: return "Fraction of time pressure level is above model surface";
  case 1336: return "U * geopotential height";
  case 1337: return "V * geopotential height";
  case 1338: return "Virtual temperature";
  case 1339: return "Saturation mixing ratio";
  case 1370: return "SO4 aerosol: Aitken mode. Units: mass mixing ratio";
  case 1371: return "SO4 aerosol: accumulation mode. Units: mass mixing ratio";
  case 1372: return "SO4 aerosol: dissolved mode. Units: mass mixing ratio";
  case 1373: return "SO4 aerosol: DMS mass mixing ratio";
  case 1374: return "SO4 aerosol: SO2 mass mixing ratio";
  case 1375: return "SO4 Methyl Sulphonic Acid mass mixing ratio";
  case 1376: return "SO4 aerosol: column mass loading";
  case 1377: return "SO4 aerosol: SW radiative forcing";
  case 1379: return "NH3 gas mass mass mix ratio";
  case 1380: return "Van-Genuchten B parameter";
  case 1381: return "Clapp-Hornberger B exponent";
  case 1382: return "Leaf area index of vegetated fraction";
  case 1383: return "Canopy height of vegetated fraction";
  case 1384: return "Canopy conductance";
  case 1385: return "Unfrozen soil moisture fraction";
  case 1386: return "Frozen soil moisture fraction";
  case 1387: return "Transpiration";
  case 1388: return "Gross Primary Productivity";
  case 1389: return "Net Primary Productivity";
  case 1390: return "Plant Respiration";
  case 1391: return "Fractional covering of functional types";
  case 1392: return "LAI of veg functional types";
  case 1393: return "Canopy height of vegetation functional types";
  case 1394: return "Disturbed fraction of vegetation";
  case 1395: return "Soil albedo";
  case 1396: return "Snow soot";
  case 1397: return "Soil carbon content";
  case 1398: return "Accumulated net primary productivity on tiles";
  case 1399: return "Mountain torque per unit area";
  case 1400: return "Surface dry deposition flux of SO2";
  case 1401: return " Surface dry deposition flux of SO4 Aitken mode";
  case 1402: return "Surface dry deposition flux of SO4 ACCUMULATION mode";
  case 1403: return "Surface dry deposition flux of SO4 DISSOLVED mode";
  case 1404: return "RESIST_B for SO2";
  case 1405: return "RESIST_B for SO2 Aitken mode";
  case 1406: return "RESIST_B for SO2 ACCUMULATION  mode";
  case 1407: return "RESIST_B for SO2 DISSOLVED mode";
  case 1408: return "RESIST_S for SO2";
  case 1409: return "RESIST_S for SO2 Aitken mode";
  case 1410: return "RESIST_S for SO2 ACCUMULATION mode";
  case 1411: return "RESIST_S for SO2 DISSOLVED  mode";
  case 1412: return "Dry deposition velocity for SO2";
  case 1413: return "Dry deposition velocity for SO4 Aitken mode";
  case 1414: return "Dry deposition velocity for SO4 ACCUMULATION mode";
  case 1415: return "Dry deposition velocity for SO4 DISSOLVED mode";
  case 1416: return "Aerodynamic resistance 1/CDSTD after TSTEP";
  case 1417: return "SO2 scavenged by convective precipitation kg(S)/m2/tstep";
  case 1418: return "SO4 Aitken scavenged by convective precipitation kg(S)/m2/tstep";
  case 1419: return "SO4 accumulation scavenged by convective precipitation kg(S)/m2/tstep";
  case 1420: return "SO4 dissolved scavenged by convective precipitation kg(S)/m2/tstep";
  case 1421: return "SO2 scavenged by large scale precipitation kg(S)/m2/tstep";
  case 1422: return "SO4 Aitken scavenged by large scale precipitation kg(S)/m2/tstep";
  case 1423: return "SO4 accumulation scavenged by large scale precipitation kg(S)/m2/tstep";
  case 1424: return "SO4 dissolved scavenged by large scale precipitation kg(S)/m2/tstep";
  case 1425: return "Layer liquid cloud amount in layers";
  case 1426: return "Layer frozen cloud amount in layers";
  case 1427: return "Layer cloud frequency in each layer";
  case 1428: return "Net energy change this period";
  case 1429: return "Thickness";
  case 1430: return "Thickness tendency";
  case 1431: return "du/dp";
  case 1432: return "dv/dp";
  case 1433: return "dtheta/dp";
  case 1434: return "dtheta_e/dp";
  case 1435: return "Moist PV";
  case 1436: return "Magnitude Geostrophic Deformation";
  case 1437: return "EW cpt, Geostrophic deformation axis";
  case 1438: return "NS cpt, Geostrophic deformation axis";
  case 1439: return "Magnitude Grad(ThetaW)";
  case 1440: return "EW cpt Grad(ThetaW)";
  case 1441: return "NS cpt Grad(ThetaW)";
  case 1442: return "Geostrophic Deformation wrt ThetaW";
  case 1443: return "Geostrophic Relative Vorticity";
  case 1444: return "Magnitude Grad(Theta)";
  case 1445: return "EW cpt Grad(Theta)";
  case 1446: return "NS cpt Grad(Theta)";
  case 1447: return "Omega eqn. inversion with diabatic forcing";
  case 1448: return "Omega eqn. inversion with divQ & diabatic forcing";
  case 1449: return "Omega eqn. inversion with divQ only";
  case 1450: return "Omega eqn. inversion with divQ 800-600mb";
  case 1451: return "Omega eqn. inversion with divQ 600-100mb";
  case 1452: return "Omega eqn. inversion with divQ 1000-800mb";
  case 1453: return "DelSqd(ThetaW)";
  case 1454: return "Local value of magnitude of grad(ThetaW)";
  case 1455: return "Theta Frontal Speed - advection of magnitude (theta_w)";
  case 1456: return "Advection of theta_w";
  case 1457: return "Geostrophic advection of theta_w";
  case 1458: return "DelSqd(Theta)";
  case 1459: return "Local value of magnitude of grad(Theta)";
  case 1460: return "Theta Frontal Speed - advection of magnitude (theta)";
  case 1461: return "Advection of theta";
  case 1462: return "Geostrophic advection of theta";
  case 1463: return "Ambient noise";
  case 1464: return "Droplet number conc * cloud amount";
  case 1465: return "Layer cloud lwc * cloud amount";
  case 1466: return "SO4 ccn mass conc * cond samp weight";
  case 1467: return "Conditional sampling weight";
  case 1468: return "2-D effective radius * 2-D re weight";
  case 1469: return "Weight for 2-D effective radius";
  case 1470: return "Advection of mixing ratio";
  case 1471: return "Advection of dew point temperature";
  case 1472: return "Advection of relative humidity";
  case 1473: return "Advection of relative vorticity";
  case 1474: return "Advection of absolute vorticity";
  case 1475: return "X Component of Isallobaric Wind";
  case 1476: return "Y Component of Isallobaric Wind";
  case 1477: return "Scalar Divergence";
  case 1478: return "Showalter index (an instability index)";
  case 1479: return "Total total index (an instability index)";
  case 1480: return "Sweat index (an instability index)";
  case 1481: return "Lifted index (an instability index)";
  case 1482: return "Cape (convective available potential energy)";
  case 1483: return "k index (an instability index)";
  case 1484: return "Saturation vapour pressure";
  case 1485: return "Modified refractivity index, M (M units)";
  case 1486: return "Vertical gradient of modified refractivity, dM/dz (M/km)";
  case 1487: return "Minimum of dM/dz with height (M/km)";
  case 1488: return "Maximum of dM/dz with height (M/km)";
  case 1489: return "Radar duct intensity (max wavelength trapped)";
  case 1490: return "Refractivity index, N (N units)";
  case 1491: return "Fresh soot mass mix ratio";
  case 1492: return "Aged soot mass mix ratio";
  case 1493: return "Soot in cloud mix ratio";
  case 1494: return "SO4 Aitken surface settlement flux";
  case 1495: return "SO4 Accumulation surface settlement flux";
  case 1496: return "MSA (methyl sulphonic acid) mass mixing ratio after tstep";
  case 1497: return "NH3 (ammonia) depletion after tstep";
  case 1498: return "Ship noise (from passing ships)";
  case 1499: return "Leaf turnover rate of plant functional types";
  case 1500: return "Accumulated leaf turnover rate on PFTs";
  case 1501: return "Accumulated phenological leaf turnover rate on PFTs";
  case 1502: return "Accumulated wood respiration on PFTs";
  case 1503: return "Accumulated soil respiration";
  case 1504: return "Canopy & surface water content on tiles";
  case 1505: return "Canopy & surface capacity on tiles";
  case 1506: return "Infiltration enhancement factor on tiles";
  case 1507: return "Snow grain size (microns)";
  case 1508: return "Snow temperature";
  case 1509: return "Radiative surface temperature";
  case 1510: return "Surface temperature on tiles";
  case 1511: return "Roughness length on tiles";
  case 1512: return "Vegetation carbon on Plant Functional Types (PFTs)";
  case 1513: return "Gridbox mean vegetation carbon";
  case 1514: return "Phenological leaf turnover rate on PFTs";
  case 1515: return "Litter carbon on Plant Functional Types (PFTs)";
  case 1516: return "Gridbox mean litter carbon";
  case 1517: return "Canopy evaporation on tiles";
  case 1518: return "Evapotranspiration from the soil";
  case 1519: return "Gross primary productivity on plant functional types";
  case 1520: return "Sensible heat flux on tiles";
  case 1521: return "Net primary productivity on plant functional types";
  case 1522: return "Plant respiration on plant functional types";
  case 1523: return "Soil respiration";
  case 1524: return "Bulk Richardson number on tiles";
  case 1525: return "Fractional snow cover";
  case 1526: return "Rate of evaporation from soil surface";
  case 1527: return "Rate of evaporation from canopy";
  case 1528: return "Rate of sublimation from surface (gridbox mean)";
  case 1529: return "Rate of transpiration";
  case 1530: return "Rate of snow melt on land";
  case 1531: return "Rate of canopy throughfall";
  case 1532: return "Rate of surface runoff";
  case 1533: return "Rate of sub-surface runoff";
  case 1534: return "Turbulent mixing ht after Boundary Layer";
  case 1535: return "Stable BL indicator";
  case 1536: return "Stratocumulus over stable BL indicator";
  case 1537: return "Well_mixed BL indicator";
  case 1538: return "Decoupled SC not over CU indicator";
  case 1539: return "Decoupled SC over CU indicator";
  case 1540: return "Cumulus-capped BL indicator";
  case 1541: return "NH3 Surface dry deposition flux";
  case 1542: return "Fresh soot surface dry deposition flux";
  case 1543: return "Aged soot surface dry deposition flux";
  case 1544: return "Soot in cloud occult deposition flux";
  case 1545: return "NH3 scavenged by large scale precipitation";
  case 1546: return "Soot scavenged by large scale precipitation";
  case 1547: return "SO2 scavenged by large scale precipitation";
  case 1548: return "SO4 Aitken scavenged by large scale precipitation";
  case 1549: return "SO4 accumulation scavenged by large scale precipitation";
  case 1550: return "SO4 dissolved scavenged by large scale precipitation";
  case 1551: return "NH3 scavenged by convective precipitation";
  case 1552: return "Soot scavenged by convective precipitation";
  case 1553: return "SO2 scavenged by convective precipitation";
  case 1554: return "SO4 Aitken scavenged by convective precipitation";
  case 1555: return "SO4 accumulation scavenged by convective precipitation";
  case 1556: return "SO4 dissolved scavenged by convective precipitation";
  case 1557: return "Potential evaporation amount";
  case 1558: return "Potential evaporation rate";
  case 1559: return "Soil moisture availability factor";
  case 1560: return "CO2 ocean flux";
  case 1561: return "CO2 surface emissions";
  case 1562: return "CO2 land surface flux";
  case 1563: return "CO2 total flux to atmosphere";
  case 1564: return "Precipitation rate codes for symbol plotting";
  case 1565: return "Present Weather codes (ww-code)";
  case 1566: return "T before dynamics";
  case 1567: return "T after dynamics";
  case 1568: return "q before dynamics";
  case 1569: return "q after dynamics";
  case 1570: return "x component of E vector = (v**2 - u**2)";
  case 1571: return "y component of E vector = -uv";
  case 1572: return "z component of E vector - proportional to vT";
  case 1573: return "Supercooled liquid water content";
  case 1574: return "Supercooled rain";
  case 1575: return "Rain fraction";
  case 1577: return "Accumulated precipitation for 6 hours (for fieldsfiles, 1998)";
  case 1578: return "Modified maximum gravity wave stress magnitude";
  case 1579: return "U in the GWD surface layer";
  case 1580: return "V in the GWD surface layer";
  case 1581: return "N in the GWD surface layer";
  case 1582: return "GWD surface Froude number";
  case 1583: return "GWD Blocked Layer Depth";
  case 1584: return "Percent of hydro GWD that is linear";
  case 1585: return "Percent of time with Hydr. Jumps";
  case 1586: return "Percent of time with Lee Waves";
  case 1587: return "Percent of time with blocked flow";
  case 1588: return "x component of GW saturation stress";
  case 1589: return "y component of GW saturation stress";
  case 1590: return "x component of GW jump stress";
  case 1591: return "y component of GW jump stress";
  case 1592: return "x component of GW wake stress";
  case 1593: return "y component of GW wake stress";
  case 1594: return "x component of GW lee stress";
  case 1595: return "y component of GW lee stress";
  case 1596: return "u-accel from GWD blocked flow";
  case 1597: return "v-accel from GWD blocked flow";
  case 1600: return "Net surface water flux";
  case 1601: return "Pressure tendency";
  case 1602: return "X Component of Thermal Wind";
  case 1603: return "Y Component of Thermal Wind";
  case 1604: return "Saturated specific humidity";
  case 1605: return "Isallobaric direction ( true )";
  case 1606: return "Isallobaric wind speed";
  case 1607: return "Geostrophic wind direction ( true )";
  case 1608: return "Geostrophic wind speed";
  case 1609: return "Thermal wind direction ( true )";
  case 1610: return "ISCCP C2 high thin cloud amount";
  case 1611: return "ISCCP C2 high medium cloud amount";
  case 1612: return "ISCCP C2 high thick cloud amount";
  case 1613: return "ISCCP C2 mid-level thin cloud amount";
  case 1614: return "ISCCP C2 mid-level thick cloud amount";
  case 1615: return "ISCCP C2 low thin cloud amount";
  case 1616: return "ISCCP C2 low thick cloud amount";
  case 1617: return "Sea Surface Temperature (SST) minus Dew point (for forecasting sea fog)";
  case 1618: return "500-850 Potential Instability Index (measure of thunder risk)";
  case 1619: return "Boyden Index";
  case 1620: return "Height of 2 deg C isotherm in feet (Navy requirement)";
  case 1621: return "Casswell maximum vertical velocity (for NMC)";
  case 1622: return "Casswell height of maximum vertical velocity (for NMC)";
  case 1623: return "Pseudo WV image from Horace - estimated radiance received";
  case 1624: return "Pseudo IR image from Horace - estimated radiance received";
  case 1625: return "Frequency unit type: 1=Hz (eg for noise fields)";
  case 1626: return "Areal fraction of intensive grassland";
  case 1627: return "Areal fraction of extensive grassland";
  case 1682: return "Cape inhibition";
  case 1690: return "C.A.T. probability derived from fieldsfiles, not model";
  case 1701: return "OD";
  case 1702: return "OP";
  case 1703: return "OH";
  case 1704: return "NO";
  case 1705: return "NO2";
  case 1706: return "NO3";
  case 1707: return "N2O5";
  case 1708: return "CO";
  case 1709: return "CH4";
  case 1710: return "HCHO";
  case 1711: return "O3";
  case 1712: return "H2";
  case 1713: return "HNO3";
  case 1714: return "H2O2";
  case 1715: return "CH3O2";
  case 1716: return "HO2";
  case 1717: return "C2H6";
  case 1718: return "C2H5O2";
  case 1719: return "CH3CHO";
  case 1720: return "CH3COO2";
  case 1721: return "PAN";
  case 1722: return "CH3OOH";
  case 1723: return "NC4H10";
  case 1724: return "SC4H9O2";
  case 1725: return "CH3COE";
  case 1726: return "C2H4";
  case 1727: return "C3H6";
  case 1728: return "C3H8";
  case 1729: return "C3H7O2";
  case 1730: return "C3H7OOH";
  case 1731: return "C2H5OOH";
  case 1732: return "C4H9OOH";
  case 1733: return "CH3OH";
  case 1734: return "ACETONE";
  case 1735: return "ACETO2";
  case 1736: return "CH3COX";
  case 1737: return "CH2O2C";
  case 1738: return "MGLYOX";
  case 1739: return "CH3CHX";
  case 1740: return "C5H8";
  case 1741: return "RO2IP1";
  case 1742: return "MVK";
  case 1743: return "RO2IP2";
  case 1744: return "ISOPOOH";
  case 1745: return "MVKOOH";
  case 1746: return "RNC2H4";
  case 1747: return "RNC3H6";
  case 1748: return "RNC5H8";
  case 1749: return "NAER";
  case 1750: return "HO2NO2";
  case 1751: return "H2O";
  case 1752: return "EXTRA";
  }
  return NULL;
}


/* returns string, or NULL if not matched */
char *pp_ppshortname(int code)
{
  switch (code) {
  case    0: return "unspecified";
  case    1: return "ht";
  case    2: return "depth";
  case    3: return "zg";
  case    4: return "icaoht";
  case    5: return "blht";
  case    8: return "p";
  case    9: return "hybrid_p";
  case   10: return "sigma";
  case   11: return "Tu";
  case   12: return "Tv";
  case   13: return "TT";
  case   14: return "Tomega";
  case   15: return "htht";
  case   16: return "temp";
  case   19: return "theta";
  case   23: return "soiltemp";
  case   24: return "dtheta_dt";
  case   28: return "dpstar_dt";
  case   34: return "convcld";
  case   37: return "iceconc";
  case   38: return "lsm";
  case   39: return "f";
  case   40: return "omega";
  case   41: return "Tw";
  case   42: return "dz_dt";
  case   43: return "eta_dot";
  case   44: return "time";
  case   45: return "dsigma_dt";
  case   46: return "uq";
  case   47: return "vq";
  case   48: return "x_wind";
  case   49: return "y_wind";
  case   50: return "wind";
  case   53: return "uomega";
  case   54: return "vomega";
  case   56: return "u";
  case   57: return "v";
  case   58: return "uu";
  case   59: return "vv";
  case   60: return "uv";
  case   61: return "taux";
  case   62: return "tauy";
  case   63: return "ke";
  case   65: return "hybrid_ht";
  case   72: return "avor";
  case   73: return "rvor";
  case   74: return "div";
  case   77: return "tot_precip";
  case   78: return "QCF";
  case   79: return "QCL";
  case   80: return "psi";
  case   81: return "chi";
  case   82: return "pv";
  case   84: return "Q";
  case   85: return "M";
  case   87: return "dq_dt";
  case   88: return "rh";
  case   90: return "precip";
  case   93: return "snowdepth";
  case   94: return "cvrain";
  case   95: return "q";
  case   96: return "water";
  case   97: return "rain";
  case   98: return "cvrain";
  case   99: return "lsrain";
  case  100: return "cvrain";
  case  101: return "mix";
  case  102: return "lsrain";
  case  103: return "snow";
  case  104: return "rain";
  case  105: return "evap";
  case  106: return "sm";
  case  107: return "sublim";
  case  108: return "snow";
  case  109: return "runoff";
  case  110: return "snowmelt";
  case  111: return "fastrunoff";
  case  112: return "slowrunoff";
  case  113: return "pme";
  case  114: return "evap";
  case  115: return "evap";
  case  116: return "lssnow";
  case  117: return "cvsnow";
  case  118: return "lssnow";
  case  119: return "cvsnow";
  case  120: return "lsp";
  case  121: return "cvp";
  case  122: return "sm";
  case  123: return "uacc";
  case  124: return "vacc";
  case  127: return "sbl";
  case  128: return "msl";
  case  129: return "surface";
  case  130: return "Trop";
  case  131: return "mwl";
  case  132: return "fl";
  case  133: return "toa";
  case  134: return "minus20Clev";
  case  135: return "ul_ht";
  case  136: return "ll_ht";
  case  137: return "ul_p";
  case  138: return "ll_p";
  case  139: return "wbfl";
  case  140: return "salinity";
  case  142: return "ul_hy";
  case  143: return "ll_hy";
  case  156: return "03";
  case  158: return "03";
  case  176: return "lat";
  case  177: return "long";
  case  178: return "sh";
  case  180: return "lh";
  case  182: return "wme";
  case  186: return "solar";
  case  187: return "longwave";
  case  205: return "ilr";
  case  206: return "olr";
  case  210: return "csolr";
  case  211: return "csilr";
  case  213: return "CAPE";
  case  218: return "convcldwater";
  case  220: return "cldamount";
  case  222: return "convcldbase";
  case  223: return "convcldtop";
  case  240: return "csolr";
  case  241: return "csilr";
  case  245: return "cshr";
  case  246: return "csswhr";
  case  247: return "cslwhr";
  case  250: return "cshr";
  case  251: return "swhr";
  case  252: return "csswhr";
  case  253: return "lwhr";
  case  254: return "cslwhr";
  case  260: return "topmelt";
  case  261: return "botmelt";
  case  285: return "evap";
  case  395: return "lsm";
  case  452: return "N20";
  case  453: return "O3";
  case  501: return "tracer1";
  case  502: return "tracer2";
  case  503: return "tracer3";
  case  504: return "tracer4";
  case  505: return "tracer5";
  case  506: return "tracer6";
  case  507: return "tracer7";
  case  508: return "tracer8";
  case  509: return "tracer9";
  case  510: return "tracer10";
  case  511: return "tracer11";
  case  512: return "tracer12";
  case  513: return "tracer13";
  case  514: return "tracer14";
  case  515: return "tracer15";
  case  516: return "tracer16";
  case  517: return "tracer17";
  case  518: return "tracer18";
  case  519: return "tracer19";
  case  520: return "tracer20";
  case  521: return "tracer21";
  case  522: return "tracer22";
  case  523: return "tracer23";
  case  524: return "tracer24";
  case  525: return "tracer25";
  case  526: return "tracer26";
  case  527: return "tracer27";
  case  528: return "tracer28";
  case  529: return "tracer29";
  case  601: return "temp";
  case  602: return "salinity";
  case  603: return "temp";
  case  604: return "temp";
  case  605: return "salinity";
  case  623: return "snowfall";
  case  624: return "sublim";
  case  625: return "SOL";
  case  626: return "HTN";
  case  627: return "WME";
  case  629: return "PLE";
  case  631: return "outflow";
  case  633: return "ISX";
  case  634: return "ISY";
  case  637: return "insitu_T";
  case  649: return "salinity";
  case  650: return "SST";
  case  680: return "W";
  case  681: return "topmelt";
  case  682: return "botmelt";
  case  683: return "iceconc";
  case  687: return "icedepth";
  case  688: return "snowdepth";
  case  701: return "ucurr";
  case  702: return "vcurr";
  case  721: return "TAUX";
  case  722: return "TAUY";
  case  801: return "otracer1";
  case  802: return "otracer2";
  case  803: return "otracer3";
  case  804: return "otracer4";
  case  805: return "otracer5";
  case  806: return "otracer6";
  case  807: return "otracer7";
  case  808: return "otracer8";
  case  809: return "otracer9";
  case  810: return "otracer10";
  case  811: return "otracer11";
  case  812: return "otracer12";
  case  813: return "otracer13";
  case  814: return "otracer14";
  case  815: return "otracer15";
  case  816: return "otracer16";
  case  817: return "otracer17";
  case  818: return "otracer18";
  case 1334: return "qomega";
  case 1335: return "psag";
  case 1336: return "uzg";
  case 1337: return "vzg";
  case 1338: return "vtemp";
  case 1508: return "temp";
  case 1509: return "temp";
  case 1510: return "temp";
  case 1566: return "temp";
  case 1567: return "temp";
  case 1568: return "q";
  case 1569: return "q";
  case 1701: return "OD";
  case 1702: return "OP";
  case 1703: return "OH";
  case 1704: return "NO";
  case 1705: return "NO2";
  case 1706: return "NO3";
  case 1707: return "N2O5";
  case 1708: return "CO";
  case 1709: return "CH4";
  case 1710: return "HCHO";
  case 1711: return "O3";
  case 1712: return "H2";
  case 1713: return "HNO3";
  case 1714: return "H2O2";
  case 1715: return "CH3O2";
  case 1716: return "HO2";
  case 1717: return "C2H6";
  case 1718: return "C2H5O2";
  case 1719: return "CH3CHO";
  case 1720: return "CH3COO2";
  case 1721: return "PAN";
  case 1722: return "CH3OOH";
  case 1723: return "NC4H10";
  case 1724: return "SC4H9O2";
  case 1725: return "CH3COE";
  case 1726: return "C2H4";
  case 1727: return "C3H6";
  case 1728: return "C3H8";
  case 1729: return "C3H7O2";
  case 1730: return "C3H7OOH";
  case 1731: return "C2H5OOH";
  case 1732: return "C4H9OOH";
  case 1733: return "CH3OH";
  case 1734: return "ACETONE";
  case 1735: return "ACETO2";
  case 1736: return "CH3COX";
  case 1737: return "CH2O2C";
  case 1738: return "MGLYOX";
  case 1739: return "CH3CHX";
  case 1740: return "C5H8";
  case 1741: return "RO2IP1";
  case 1742: return "MVK";
  case 1743: return "RO2IP2";
  case 1744: return "ISOPOOH";
  case 1745: return "MVKOOH";
  case 1746: return "RNC2H4";
  case 1747: return "RNC3H6";
  case 1748: return "RNC5H8";
  case 1749: return "NAER";
  case 1750: return "HO2NO2";
  case 1751: return "H2O";
  case 1752: return "EXTRA";
  }
  return NULL;
}

/* returns string, or NULL if not matched */
char *pp_ppunit(int code)
{
  switch (code) {
  case    0: return "unspecified";
  case    1: return "m";
  case    2: return "m";
  case    3: return "m2 s-2";
  case    4: return "kft";
  case    5: return "m";
  case    6: return "level";
  case    7: return "Pa";
  case    8: return "Pa";
  case    9: return "level";
  case   10: return "sigma_level";
  case   11: return "K m s-1";
  case   12: return "K m s-1";
  case   13: return "K2";
  case   14: return "K Pa s-1";
  case   15: return "m2";
  case   16: return "K";
  case   17: return "K";
  case   18: return "K";
  case   19: return "K";
  case   20: return "K";
  case   21: return "K";
  case   22: return "K";
  case   23: return "K";
  case   24: return "K s-1";
  case   25: return "m";
  case   26: return "s-1";
  case   27: return "kg m-3";
  case   28: return "Pa s-1";
  case   30: return "0-1";
  case   35: return "kft";
  case   36: return "0-1";
  case   37: return "0-1";
  case   39: return "s-1";
  case   40: return "Pa s-1";
  case   41: return "K";
  case   42: return "m s-1";
  case   43: return "s-1";
  case   44: return "s";
  case   45: return "s-1";
  case   46: return "m kg s-1 kg-1";
  case   47: return "m kg s-1 kg-1";
  case   48: return "m s-1";
  case   49: return "m s-1";
  case   50: return "m s-1";
  case   51: return "m s-1";
  case   53: return "m Pa s-2";
  case   54: return "m Pa s-2";
  case   55: return "degrees";
  case   56: return "m s-1";
  case   57: return "m s-1";
  case   58: return "m2 s-2";
  case   59: return "m2 s-2";
  case   60: return "m2 s-2";
  case   61: return "N m-2";
  case   62: return "N m-2";
  case   63: return "J";
  case   65: return "level";
  case   68: return "m s-2";
  case   69: return "m s-2";
  case   70: return "m s-2";
  case   71: return "m s-2";
  case   72: return "s-1";
  case   73: return "s-1";
  case   74: return "s-1";
  case   75: return "feet";
  case   76: return "feet";
  case   77: return "kg m-2";
  case   78: return "kg kg-1";
  case   79: return "kg kg-1";
  case   80: return "m2 s-1";
  case   81: return "m2 s-1";
  case   82: return "K m2 s-1 kg-1";
  case   84: return "K m2 s-1 kg-1";
  case   85: return "m2 s-2";
  case   86: return "s-1";
  case   87: return "kg kg-1 s-1";
  case   89: return "kg m-2";
  case   90: return "kg m-2 s-1";
  case   91: return "m";
  case   92: return "m";
  case   93: return "kg m-2";
  case   94: return "kg m-2";
  case   95: return "kg kg-1";
  case   96: return "kg m-2";
  case   97: return "kg m-2 s-1";
  case   98: return "kg m-2 s-1";
  case   99: return "kg m-2 s-1";
  case  100: return "kg m-2 s-1";
  case  101: return "kg kg-1";
  case  102: return "kg m-2";
  case  103: return "kg m-2";
  case  104: return "kg m-2";
  case  105: return "kg m-2";
  case  106: return "kg m-2";
  case  107: return "kg m-2";
  case  108: return "kg m-2 s-1";
  case  109: return "kg m-2";
  case  110: return "kg m-2";
  case  111: return "kg m-2";
  case  112: return "kg m-2";
  case  113: return "kg m-2 s-1";
  case  114: return "kg m-2 s-1";
  case  115: return "kg m-2";
  case  116: return "kg m-2";
  case  117: return "kg m-2";
  case  118: return "kg m-2 s-1";
  case  119: return "kg m-2 s-1";
  case  120: return "kg m-2";
  case  121: return "kg m-2";
  case  122: return "kg m-2";
  case  123: return "m s-2";
  case  124: return "m s-2";
  case  126: return "level";
  case  127: return "level";
  case  128: return "level";
  case  129: return "level";
  case  130: return "level";
  case  131: return "level";
  case  132: return "level";
  case  133: return "level";
  case  134: return "level";
  case  135: return "kft";
  case  136: return "kft";
  case  137: return "mbar";
  case  138: return "mbar";
  case  139: return "m";
  case  140: return "kg kg-1";
  case  141: return "W m-2";
  case  142: return "level";
  case  143: return "level";
  case  148: return "m s-1";
  case  149: return "m s-1";
  case  150: return "m";
  case  151: return "m";
  case  155: return "m";
  case  156: return "kg m-2";
  case  158: return "Dobson";
  case  159: return "0-12";
  case  161: return "K";
  case  162: return "hr";
  case  173: return "0-1";
  case  175: return "m";
  case  176: return "degrees_north";
  case  177: return "degrees_east";
  case  178: return "W m-2";
  case  179: return "W m-2";
  case  180: return "W m-2";
  case  182: return "W m-2";
  case  184: return "kg m-2 s-1";
  case  185: return "kg m-2 s-1";
  case  186: return "W m-2";
  case  187: return "W m-2";
  case  188: return "W m-2";
  case  189: return "K (6hr)-1";
  case  190: return "0-1";
  case  191: return "0-1";
  case  193: return "K s-1";
  case  195: return "N m-2";
  case  196: return "N m-2";
  case  197: return "W m-2";
  case  198: return "m";
  case  199: return "m";
  case  200: return "W m-2";
  case  201: return "W m-2";
  case  202: return "W m-2";
  case  203: return "W m-2";
  case  205: return "W m-2";
  case  206: return "W m-2";
  case  207: return "W m-2";
  case  208: return "W m-2";
  case  209: return "K";
  case  210: return "W m-2";
  case  211: return "W m-2";
  case  213: return "J kg-1";
  case  214: return "W m-2";
  case  215: return "W m-2";
  case  216: return "kft";
  case  218: return "kg kg-1";
  case  219: return "kg m-2";
  case  220: return "0-1";
  case  228: return "K s-1";
  case  229: return "K kg m-2 s-1";
  case  230: return "K kg m-2 s-1";
  case  231: return "K kg m-2 s-1 kg-1";
  case  232: return "K kg m-2 s-1 kg-1";
  case  233: return "K kg m-2 s-1";
  case  234: return "K kg m-2 s-1";
  case  235: return "K kg m-2 s-1 kg-1";
  case  236: return "K kg m-2 s-1 kg-1";
  case  237: return "W m-2";
  case  238: return "W m-2";
  case  239: return "Pa";
  case  240: return "W m-2";
  case  241: return "W m-2";
  case  242: return "0-1";
  case  243: return "W m-2";
  case  244: return "W m-2";
  case  245: return "W m-2";
  case  246: return "K s-1";
  case  247: return "K s-1";
  case  248: return "m s-1";
  case  249: return "m s-1";
  case  250: return "K s-1";
  case  251: return "K s-1";
  case  252: return "K s-1";
  case  253: return "K s-1";
  case  254: return "K s-1";
  case  259: return "W m-2";
  case  260: return "W m-2";
  case  261: return "W m-2";
  case  262: return "0-1";
  case  263: return "N";
  case  264: return "N";
  case  265: return "N";
  case  266: return "N";
  case  267: return "kg s-3";
  case  268: return "kg s-3";
  case  269: return "kg2 s-3";
  case  270: return "kg2 s-3";
  case  271: return "kg m-2";
  case  272: return "kg m-2";
  case  273: return "kg m-2";
  case  274: return "kg m-2";
  case  275: return "m";
  case  276: return "Bq m-3";
  case  277: return "Bq s m-3";
  case  278: return "Bq m-2";
  case  279: return "Bq m-2";
  case  280: return "W m-2";
  case  281: return "W m-2";
  case  282: return "W m-2";
  case  283: return "W m-2";
  case  284: return "Bq m-2";
  case  285: return "kg m-2 s-1";
  case  286: return "micro g kg-1";
  case  287: return "micro g m-2 s-1";
  case  299: return "kg kg-1";
  case  303: return "Pa";
  case  304: return "K";
  case  305: return "m s-1";
  case  306: return "m s-1";
  case  308: return "0-1";
  case  310: return "kg m-2 s-1";
  case  315: return "kg kg-1";
  case  316: return "K";
  case  317: return "K";
  case  318: return "m s-1";
  case  319: return "m s-1";
  case  320: return "m";
  case  321: return "m";
  case  323: return "s m-1";
  case  324: return "m";
  case  325: return "kg m-2";
  case  326: return "0-1";
  case  333: return "kg m-2 s-1";
  case  335: return "J m-3 K-1";
  case  336: return "J m-1 K-1 s-1";
  case  342: return "m";
  case  343: return "kg m-2";
  case  344: return "Pa";
  case  345: return "Pa";
  case  346: return "kft";
  case  347: return "kft";
  case  348: return "K m2 s-1 kg-1";
  case  349: return "K m2 s-1 kg-1";
  case  350: return "K m s-1 kg-1";
  case  366: return "N m-2";
  case  367: return "m";
  case  370: return "m s-1";
  case  371: return "degrees";
  case  372: return "m";
  case  373: return "m s-1";
  case  374: return "degrees";
  case  375: return "m";
  case  376: return "s";
  case  377: return "m s-1";
  case  378: return "m";
  case  379: return "s";
  case  380: return "m s-1";
  case  384: return "K";
  case  385: return "m";
  case  386: return "m";
  case  387: return "m";
  case  388: return "s";
  case  389: return "radians";
  case  390: return "s";
  case  391: return "radians";
  case  393: return "s";
  case  394: return "radians";
  case  396: return "m";
  case  501: return "kg kg-1";
  case  502: return "kg kg-1";
  case  503: return "kg kg-1";
  case  504: return "kg kg-1";
  case  505: return "kg kg-1";
  case  506: return "kg kg-1";
  case  507: return "kg kg-1";
  case  508: return "kg kg-1";
  case  509: return "kg kg-1";
  case  510: return "kg kg-1";
  case  511: return "kg kg-1";
  case  512: return "kg kg-1";
  case  513: return "kg kg-1";
  case  514: return "kg kg-1";
  case  515: return "kg kg-1";
  case  516: return "kg kg-1";
  case  517: return "kg kg-1";
  case  518: return "kg kg-1";
  case  519: return "kg kg-1";
  case  520: return "kg kg-1";
  case  521: return "kg kg-1";
  case  522: return "kg kg-1";
  case  523: return "kg kg-1";
  case  524: return "kg kg-1";
  case  525: return "kg kg-1";
  case  526: return "kg kg-1";
  case  527: return "kg kg-1";
  case  528: return "kg kg-1";
  case  529: return "kg kg-1";
  case  572: return "kg m-2 s-1";
  case  573: return "kg m-2 s-1";
  case  601: return "degC";
  case  602: return "(psu-35)/1000";
  case  603: return "degC";
  case  604: return "degC";
  case  605: return "(psu-35)/1000";
  case  608: return "cm";
  case  609: return "kg m-3";
  case  610: return "m";
  case  611: return "cm3 s-1";
  case  612: return "cm3 s-1";
  case  613: return "cm3 s-1 ts-1";
  case  614: return "cm3 s-1 ts-1";
  case  617: return "Pa";
  case  618: return "s-2";
  case  619: return "m";
  case  620: return "W m-2";
  case  621: return "m";
  case  622: return "m";
  case  623: return "kg m-2 s-1";
  case  624: return "kg m-2 s-1";
  case  625: return "W m-2";
  case  626: return "W m-2";
  case  627: return "W m-2";
  case  628: return "W m-2";
  case  629: return "kg m-2 s-1";
  case  630: return "W m-2";
  case  631: return "kg m-2 s-1";
  case  632: return "m s-1";
  case  633: return "N m-2";
  case  634: return "N m-2";
  case  635: return "m-2 s-2";
  case  636: return "kg m-1 s-3";
  case  637: return "K";
  case  640: return "K s-1";
  case  641: return "K s-1";
  case  642: return "K s-1";
  case  643: return "K s-1";
  case  644: return "K s-1";
  case  645: return "K s-1";
  case  646: return "K s-1";
  case  647: return "K s-1";
  case  648: return "psu s-1";
  case  649: return "(psu-35)/1000";
  case  650: return "degC";
  case  651: return "W m-2";
  case  652: return "W m-2";
  case  653: return "m";
  case  654: return "m";
  case  655: return "J";
  case  656: return "J";
  case  657: return "m2 s-2";
  case  658: return "cm2 s-1";
  case  660: return "s-2";
  case  661: return "s-2";
  case  662: return "s-2";
  case  663: return "s-2";
  case  664: return "s-2";
  case  665: return "cm s-2";
  case  666: return "cm s-2";
  case  667: return "cm s-2";
  case  668: return "cm s-2";
  case  669: return "cm s-2";
  case  671: return "W m-2";
  case  672: return "kg m-2 s-1";
  case  675: return "m";
  case  676: return "kg m-2";
  case  677: return "Pa";
  case  678: return "W m-2";
  case  679: return "kg m-2 s-1";
  case  680: return "cm s-1";
  case  681: return "W m-2";
  case  682: return "W m-2";
  case  684: return "W m-2";
  case  685: return "W m-2";
  case  686: return "psu s-1";
  case  687: return "m";
  case  688: return "m";
  case  689: return "N m-2";
  case  690: return "N m-2";
  case  692: return "m";
  case  694: return "W m-2";
  case  698: return "W m-2";
  case  699: return "m";
  case  701: return "cm s-1";
  case  702: return "cm s-1";
  case  703: return "cm s-1";
  case  704: return "cm s-1";
  case  711: return "cm s-1";
  case  712: return "cm s-1";
  case  713: return "cm s-2";
  case  714: return "cm s-2";
  case  715: return "cm-1";
  case  718: return "m2 s-1";
  case  719: return "m2 s-1";
  case  721: return "N m-2";
  case  722: return "N m-2";
  case  728: return "m s-1";
  case  729: return "m s-1";
  case  730: return "m s-1";
  case  731: return "m s-1";
  case  732: return "m s-1";
  case  733: return "Pa";
  case  734: return "Pa";
  case  735: return "Pa";
  case  736: return "Pa";
  case  737: return "Pa";
  case  738: return "Pa";
  case  739: return "Pa";
  case  741: return "m s-2";
  case  742: return "m s-2";
  case  743: return "m s-2";
  case  744: return "m s-2";
  case  745: return "m s-2";
  case  746: return "m s-2";
  case  747: return "m s-2";
  case  748: return "m s-2";
  case  749: return "m s-2";
  case  750: return "m s-2";
  case  820: return "m";
  case  829: return "km";
  case  834: return "K s-1";
  case  835: return "m s-1";
  case  836: return "m";
  case  838: return "ppmv";
  case  918: return "s-1";
  case  919: return "m s-1";
  case  920: return "m s-1";
  case 1334: return "kg kg-1 Pa s-1";
  case 1335: return "0-1";
  case 1336: return "m3 s-3";
  case 1337: return "m3 s-3";
  case 1338: return "K";
  case 1370: return "kg kg-1";
  case 1371: return "kg kg-1";
  case 1372: return "kg kg-1";
  case 1373: return "kg kg-1";
  case 1374: return "kg kg-1";
  case 1375: return "kg kg-1";
  case 1376: return "kg m-2";
  case 1377: return "W m-2";
  case 1379: return "kg kg-1";
  case 1383: return "m";
  case 1393: return "m";
  case 1398: return "kg C m-2 s-1";
  case 1399: return "N m-1";
  case 1400: return "kg m-2 s-1";
  case 1401: return "kg m-2 s-1";
  case 1402: return "kg m-2 s-1";
  case 1403: return "kg m-2 s-1";
  case 1407: return "kg m-2 s-1";
  case 1428: return "J m2";
  case 1429: return "m";
  case 1430: return "m s-1";
  case 1431: return "m s-1 Pa-1";
  case 1432: return "m s-1 Pa-1";
  case 1433: return "K Pa-1";
  case 1434: return "K Pa-1";
  case 1435: return "K m2 s-1 kg-1";
  case 1489: return "cm";
  case 1491: return "kg kg-1";
  case 1492: return "kg kg-1";
  case 1493: return "kg kg-1";
  case 1494: return "kg m-2 s-1";
  case 1495: return "kg m-2 s-1";
  case 1496: return "kg kg-1";
  case 1497: return "kg kg-1";
  case 1499: return "360days";
  case 1500: return "s-1";
  case 1501: return "s-1";
  case 1502: return "kg C m-2 s-1";
  case 1503: return "kg C m-2 s-1";
  case 1504: return "kg m-2";
  case 1508: return "K";
  case 1509: return "K";
  case 1510: return "K";
  case 1511: return "m";
  case 1512: return "kg C m-2";
  case 1513: return "kg C m-2";
  case 1514: return "s-1";
  case 1515: return "kg C m-2 year-1";
  case 1516: return "kg C m-2 year-1";
  case 1517: return "kg m-2 s-1";
  case 1518: return "kg m-2 s-1";
  case 1519: return "kg C m-2 s-1";
  case 1520: return "W m-2";
  case 1521: return "kg C m-2 s-1";
  case 1522: return "kg C m-2 s-1";
  case 1523: return "kg C m-2 s-1";
  case 1525: return "0-1";
  case 1526: return "kg m-2 s-1";
  case 1527: return "kg m-2 s-1";
  case 1528: return "kg m-2 s-1";
  case 1529: return "kg m-2 s-1";
  case 1530: return "kg m-2 s-1";
  case 1531: return "kg m-2 s-1";
  case 1532: return "kg m-2 s-1";
  case 1533: return "kg m-2 s-1";
  case 1534: return "m";
  case 1541: return "kg m-2 s-1";
  case 1542: return "kg m-2 s-1";
  case 1543: return "kg m-2 s-1";
  case 1544: return "kg m-2 s-1";
  case 1545: return "kg m-2 s-1";
  case 1546: return "kg m-2 s-1";
  case 1547: return "kg m-2 s-1";
  case 1548: return "kg m-2 s-1";
  case 1549: return "kg m-2 s-1";
  case 1550: return "kg m-2 s-1";
  case 1551: return "kg m-2 s-1";
  case 1552: return "kg m-2 s-1";
  case 1553: return "kg m-2 s-1";
  case 1554: return "kg m-2 s-1";
  case 1555: return "kg m-2 s-1";
  case 1556: return "kg m-2 s-1";
  case 1557: return "kg m-2 tstep-1";
  case 1558: return "kg m-2 s-1";
  case 1560: return "kg m-2 s-1";
  case 1561: return "kg m-2 s-1";
  case 1562: return "kg m-2 s-1";
  case 1563: return "kg m-2 s-1";
  case 1564: return "kg m-2 s-1";
  case 1578: return "N m-2";
  case 1579: return "m s-1";
  case 1580: return "m s-1";
  case 1583: return "m";
  case 1584: return "%";
  case 1585: return "%";
  case 1586: return "%";
  case 1587: return "%";
  case 1588: return "N m-2";
  case 1589: return "N m-2";
  case 1590: return "N m-2";
  case 1591: return "N m-2";
  case 1592: return "N m-2";
  case 1593: return "N m-2";
  case 1594: return "N m-2";
  case 1595: return "N m-2";
  case 1596: return "m s-2";
  case 1597: return "m s-2";
  case 1600: return "kg m-2 s-1";
  }
  return NULL;
}

#endif
